<?php
    /**
     * @author Mat <mat_sf@users.sourceforge.net>
     */
    class FPStatsBaseClass {

        public function record() {
            $dbWriter = new DBWriter();

            $dbWriter->record();
        }

        public function loadByDates($from,$to) {
            $data = array();
            $iterator = $this->loadByDatesIterator($from, $to);
            foreach ($iterator as $key => $record) {
                $data[] = $record;
            }
            return $data;
        }

        public function loadByDatesIterator($from,$to) {
            $fromTimestamp = strtotime($from);
            $toTimestamp = strtotime($to) + 60*60*24;

            if ($fromTimestamp > $toTimestamp) {
                return false;
            }

            $dbReader = new DBReader($fromTimestamp, $toTimestamp);

            return $dbReader->load();
        }
    }

?>
