<?php
// Turn off all error reporting
error_reporting(0);
	
    require_once(plugin_getdir("fpstats") . "classes/core/util/DataSorter.php");
    
    /**
     * @author Mat <mat_sf@users.sourceforge.net>
     */
    class admin_plugin_fpstats extends AdminPanelAction {

        var $langres = "plugin:fpstats";
        private $from;
        private $to;

		function setup() {
                $this->smarty->assign('admin_resource', "plugin:fpstats/admin.plugin.fpstats");

                if (isset($_SESSION["fpstatsFrom"])) {
                    $this->from = $_SESSION["fpstatsFrom"];
                } else {
                    $this->from = date("1.m.Y");
                }
                $this->smarty->assign('from',$this->from);

                if (isset($_SESSION["fpstatsTo"])) {
                    $this->to = $_SESSION["fpstatsTo"];
                } else {
                    $this->to = date("d.m.Y");
                }
                $this->smarty->assign('to',$this->to);
		}

            function main() {

                if ($this->drawGraph() || $this->drawSWGraph()) {
                    return;
                }

                global $fp_config;
                //$homeURL = $fp_config["general"]["www"];
                if (isset($_SESSION["fpstatsAction"])) {
                    $action = $_SESSION["fpstatsAction"];
                } else {
                    $action = "fpstatsOverview";
                }

                if ($action=="fpstatsDayStats") {
                    $this->prepareDayStats();
                } elseif($action=="fpstatsRawData") {
                    $homeURL = "http://" . $_SERVER ['SERVER_NAME'];
                    $this->smarty->assign("homeURL",$homeURL);
                    $this->prepareRawData();
                } elseif($action=="fpstatsOverview") {
                    $this->prepareOverview();
                } elseif($action=="fpstatsSWGraph") {
                    $this->prepareSWGraph();
                } elseif($action=="fpstatsPurgeCache") {
                    $hitsFacade = new HitsFacade();
                    $hitsFacade->prepareAll();
                }
                $this->smarty->assign("fpAction",$action);
            }

		function onsubmit() {
                global $fp_config;
                $regexp = "/^\d{1,2}\.\d{1,2}.\d{2,4}$/";

                if (isset($_POST["fpstatsFrom"]) && preg_match($regexp, $_POST["fpstatsFrom"])>0) {
                    $_SESSION["fpstatsFrom"] = $_POST["fpstatsFrom"];
                }

                if (isset($_POST["fpstatsTo"]) && preg_match($regexp, $_POST["fpstatsTo"])>0) {
                    $_SESSION["fpstatsTo"] = $_POST["fpstatsTo"];
                }

                if (isset($_POST["fpstatsOverview"])) {
                    $_SESSION["fpstatsAction"] = "fpstatsOverview";
                } elseif(isset($_POST["fpstatsRawData"])) {
                    $_SESSION["fpstatsAction"] = "fpstatsRawData";
                } elseif(isset($_POST["fpstatsDayStats"])) {
                    $_SESSION["fpstatsAction"] = "fpstatsDayStats";
                } elseif(isset($_POST["fpstatsSWGraph"])) {
                    $_SESSION["fpstatsAction"] = "fpstatsSWGraph";
                } elseif(isset($_POST["fpstatsPurgeCache"])) {
                    $_SESSION["fpstatsAction"] = "fpstatsPurgeCache";
                }
                return 2;
		}

            public function prepareOverview() {
                global $fp_config;

                $link = $fp_config['general']['www'].substr($_SERVER["REQUEST_URI"],1+strrpos($_SERVER["REQUEST_URI"],"/"))."&amp;graph=1";
                $this->smarty->assign("yearStatsLink",$link);//BLOG_BASEURL."fp-plugins/fpstats/getGraph.php");
                
            }

            public function prepareDayStats() {
                $hitsFacade = new HitsFacade();
                $summary = $hitsFacade->getLimited($this->from, $this->to);

                if (is_array($summary)) {
                    krsort($summary);
                }
                $this->smarty->assign('summary',$summary);

                //$this->smarty->assign("debugfpstats","all: ".$allHits." unique: ".$uniqueHits);
            }

            public function prepareRawData() {
                $fpStatsBaseClass = new FPStatsBaseClass();
                $data = $fpStatsBaseClass->loadByDates($this->from,$this->to);

                $dataSorter = new DataSorter($data);
                unset($data);
                $dataSorter->sortByDate();
                $this->smarty->assign('data',$dataSorter->getData());
            }

            public function drawGraph() {
                global $fp_config, $lang;

                if (!isset($_GET["graph"])) {
                    return false;
                }

                $hitsGraph = new HitsGraph();

                return $hitsGraph->getStats();

                return false;
            }

            public function prepareSWGraph() {
                global $fp_config;

                $link = $fp_config['general']['www'].substr($_SERVER["REQUEST_URI"],1+strrpos($_SERVER["REQUEST_URI"],"/"))."&amp;graphSW=1";
                $this->smarty->assign("yearStatsLink",$link);//BLOG_BASEURL."fp-plugins/fpstats/getGraph.php");

            }

            public function drawSWGraph() {
                global $fp_config, $lang;

                if (!isset($_GET["graphSW"])) {
                    return false;
                }

                $swGraph = new SWGraph();

                return $swGraph->getStats();

                return false;
            }
    }
?>
